//********************************************************************************************************************************
//*                                                                                                                              *
//*     TRegistration 2.1.24.299  3delite 2006-2024                                                                             *
//*     See TRegistration ReadMe.txt for details                                                                                 *
//*                                                                                                                              *
//* Two licenses are available if you like this component:                                                                       *
//* Shareware license: 125                                                                                                      *
//*     http://www.shareit.com/product.html?productid=300091298                                                                  *
//* Commercial license: 250                                                                                                     *
//*     http://www.shareit.com/product.html?productid=300091297                                                                  *
//*                                                                                                                              *
//*     https://www.3delite.hu/Object Pascal Developer Resources/tregistration.html                                              *
//*                                                                                                                              *
//* If you have any of the aforementioned please email: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit CalcReg;

interface

uses
    SysUtils;

    function CalcRegNum(Name, EMail: String; RegRandomSeed: Double): Integer;
    function CalcVerCode(RegNumber: Int64; VerRandomSeed: Double): Integer;

implementation

function CalcVerCode(RegNumber: Int64; VerRandomSeed: Double): Integer;
const
    MUT1 = 3266777;
var
    Previous8087CW: Word;
    VerCode: Int64;
begin
    Previous8087CW := Get8087CW;
    Set8087CW($133F);

	VerCode := RegNumber;

    if (Round((VerCode * VerCode) / (MUT1 * VerRandomSeed))) = 0
        then while (Round((VerCode * VerCode) / (MUT1 * VerRandomSeed))) = 0
            do VerCode := VerCode div 2;

    VerCode := Abs(Round((VerCode * VerCode) / (MUT1 * VerRandomSeed)));

    while VerCode < 1000000000000
		do VerCode := VerCode * 10;

    Result := VerCode div 10000000;

    Set8087CW(Previous8087CW);
end;

function CalcRegNum(Name, Email: String; RegRandomSeed: Double): Integer;
var
    Previous8087CW: Word;
    mut_Name: Cardinal;
    mut_Mail: Cardinal;
    RegCode: Longword;
    i: Integer;
    sChar: String;
    rChar: Char;
begin

    Previous8087CW := Get8087CW;
    Set8087CW($133F);

    mut_Name := 1;
    mut_Mail := 1;

{$RANGECHECKS OFF}
{$OVERFLOWCHECKS OFF}

  	for i := 1 to Length(Name) do begin
        sChar := Copy(Name, i, 1);
        rChar := sChar[1];
    	mut_Name := mut_Name * Round(Integer(rChar) * Pi);
        if mut_Name < 1
            then mut_Name := Round(RegRandomSeed * 1000);
    end;

    for i := 1 to Length(Email) do begin
        sChar := Copy(Email, i, 1);
        rChar := sChar[1];
    	mut_Mail := mut_Mail * Round(Integer(rChar) * Pi);
        if mut_Mail < 1
            then mut_Mail := Round(RegRandomSeed * 1000);
    end;

    while (mut_Mail * mut_Name = 0)
    OR (mut_Mail * mut_Name > High(Longword) div 3)
    do begin
        if mut_Mail > 4
            then mut_Mail := mut_Mail div 4;
        if mut_Name > 4
            then mut_Name := mut_Name div 4;
    end;

    RegCode := mut_Mail * mut_Name;

    while RegCode < 1000000000
		do RegCode := RegCode * 10;

    Result := RegCode div 10000;

    Set8087CW(Previous8087CW);

end;

end.
